   #  #                                               #   #
   #  #            ########################           #   #
   #  #            #  es_AddMap 0.3aBETA  #           #   #
   #  #            # Created by JoeyT2008 #           #   #
   #  #            ########################           #   #
   #  #                                               #   #
##############################################################
# Description: es_AddMap allows you to easily download maps  #
# from the net onto your server, and also your FTP if fast-  #
# download is enabled. It checks given web index's for the   #
# map you want to download, and if it finds it, it will      #
# retrieve the file, store it, unzip/unbzip/bzip and shove   #
# it in your maps folder. All within about 10 seconds after  #
# initial buffer. If es_AddMap does not find the map, theres #
# always the option to check FPSbanana for it! And if found  #
# there, the same procedure is repeated. Perfect.            #
##############################################################
   #  #                                               #   #
##############################################################
# Credits: Errant - Lots of help and ideas.                  #
#          GODJonez - Help with binary file write, and also  #
#                     helping with unrar.exe issues. Thx.    #
#                     He is also the one who found out why   #
#                     es_AddMap wasn't running on Linux and  #
#                     also supplied to the fix. Thanks GJ!   #
#          Porsche911 - Reminding me of needs to be done. xD #
##############################################################
   #  #                                               #   #
##############################################################
# Bugs: From extensive testing, I have found no bugs. But if #
# YOU find bugs, please reply in the es_AddMap thread on     #
# mattie.info. Thanks.                                       #
##############################################################
   #  #                                               #   #
##############################################################
# UNRAR: To be able to unrar maps, python needs to have the  #
# winrar unrar file to work with. If you would like to use   #
# this feature, please extract UnRAR.exe (Windows) or unrar  #
# (Linux) from the winrar archive (http://www.rarlab.com)    #
# and place it in the es_AddMap folder. Untested on Linux.   #
##############################################################
             # Thankyou for reading. JoeyT2008 #
             ###################################

# EventScripts Imports
import es, usermsg, playerlib, popuplib, gamethread

# System Imports
import threading, os

# Web Imports
import urllib, ftplib

# Compression
import bz2, zipfile

######################
# Plugin Information #
######################
info = es.AddonInfo() 
info.name     = "es_AddMap: Automatic map installer."
info.version  = "0.3aBETA"
info.url      = "http://mattie.info/cs"
info.basename = "es_addmap"
info.author   = "JoeyT2008"

#################
# Configuration #
#################

# Web index's to scan for maps.
addmap_urls = ["http://www.example.com/maps/"]

# SteamID's allowed to use the !maps command to add maps to the server.
addmap_admins = ["STEAM_0:1:12280641", "STEAM_ID_LAN"]

# If fast download is enabled on the server, set this to 1.
addmap_fastdownload = 0

# If the map could not be found in the web index's, search fpsbanana for it?
addmap_fpsbanana = 1

# Timeout after X seconds of downloading one map. 
addmap_timeout = 600

# Enable download progress bar?
addmap_progressbar = 1

# Map prefix limit. Only maps that start with this prefix can be downloaded via the !maps command. [] for all maps.
addmap_prefix = []

# Add maps downloaded from the !maps menu to the maplist?
addmap_addtomaplist = 1

#####################################
# FTP Information for Fast-Download #
#####################################

# FTP Hostname.
addmap_ftphost = "ftp.example.com"

# FTP Port. Default: 21
addmap_ftpport = 21

# FTP Username.
addmap_ftplogin = "username"

# FTP Password.
addmap_ftppassword = "password"

# Exact path to maps folder on the FTP with a trailing slash.
addmap_ftpmappath = "/www/cstrike/maps/"

# Overwrite existing maps on the FTP?
addmap_ftpoverwrite = 0

########################
# End of Configuration #
########################

addmap_installpath = str(es.ServerVar('eventscripts_gamedir')) + "/maps/"
addmap_downloadpath = str(es.ServerVar('eventscripts_addondir')) + "/es_addmap/temp/"
es.ServerVar("eventscripts_addmap", info.version, "Version of es_AddMap that is running.").makepublic()
gameSupport = {"Counter-Strike: Source": 2, "Day of Defeat: Source": 10, "Team Fortress": 297}
addmap_allowedexts = ["bsp", "bz2", "zip"]
if es.ServerVar("os") == "Windows":
    addmap_rarcmd = "%s/UnRAR.exe" % es.getAddonPath("es_addmap")
    if os.path.exists(addmap_rarcmd):
        addmap_allowedexts = ["bsp", "bz2", "zip", "rar"]
elif es.ServerVar("os") == "Linux":
    addmap_rarcmd = "%s/unrar" % es.getAddonPath("es_addmap")
    if os.path.exists(addmap_rarcmd):
        addmap_allowedexts = ["bsp", "bz2", "zip", "rar"]
addmap_dlpercent = None
addmap_currentmap = None

def load():
    ResetVars()
    CreateDirs()
    
    if not es.exists("command", "AddMap"):
        es.regcmd("AddMap", "es_addmap/AddMap_Command")
    if not es.exists("command", "addmap_Cancel"):
        es.regcmd("AddMap_Cancel", "es_AddMap/AddMap_Cancel")
    es.regclientcmd("AddMap", "es_addmap/AddMap_Command")
    ProgressBarDisplay()

def unload():
    gamethread.cancelDelayed("ProgressBarDisplay")
    es.unregclientcmd("AddMap")
    ClearTemp()

def CreateDirs():
    try:
        if not os.path.exists(addmap_downloadpath):
            os.mkdir(addmap_downloadpath)
        if not os.path.exists(addmap_installpath):
            os.mkdir(addmap_installpath)
        if not os.path.exists(str(es.ServerVar("eventscripts_addondir")) + "/es_addmap/temp/rar/"):
            os.mkdir(str(es.ServerVar("eventscripts_addondir")) + "/es_addmap/temp/rar/")
        if not os.path.exists(es.getAddonPath("es_addmap") + "/maps.txt"):
            open(es.getAddonPath("es_addmap") + "/maps.txt", "w").close()
    except:
        pass

def ClearTemp():
    try:
        for file in os.listdir(addmap_downloadpath):
            os.remove(addmap_downloadpath + file)
    except:
        pass

def ResetVars():
    global addmap_currentmap, addmap_dlpercent
    addmap_dlpercent = -1
    addmap_currentmap = ""

def AddMap_Command():
    stop = 0
    userid = es.getcmduserid()
    if es.exists("userid", userid):
        if es.getplayersteamid(userid) in addmap_admins:
            stop = 0
        else:
            conprint(userid, "[AddMap] You are not authorised to run this command.")
            stop = 1
    else:
        userid = None
    if es.getargc() >= 2 and es.getargc() <= 4 and stop == 0:
        map = es.getargv(1)
        add = 0
        if es.getargc() == 3:
            add = es.getargv(2)
        overwrite = 0
        if es.getargc() == 4:
            overwrite = es.getargv(3)
        AddMap(map, add, overwrite, None, userid).start()
    elif stop == 0:
        if not userid == None:
            conprint(userid, "Syntax: AddMap <map> [Add to Maplists] [Overwrite Existing]")
        else:
            es.dbgmsg(0, "Syntax: AddMap <map> [Add to Maplists] [Overwrite Existing]")

class progressBar:
    def __init__(self, minValue = 0, maxValue = 10):
        self.min = minValue
        self.max = maxValue
        self.span = maxValue - minValue
        self.amount = 0
        self.updateAmount(0)

    def updateAmount(self, newAmount = 0):
        if newAmount < self.min: newAmount = self.min
        if newAmount > self.max: newAmount = self.max
        self.amount = newAmount
        diffFromMin = float(self.amount - self.min)
        self.percentage = int(round((diffFromMin / float(self.span)) * 100.0))

    def __str__(self):
        return str(self.percentage)

def MapReportHook(count, blockSize, totalSize):
    global addmap_dlpercent
    prog = progressBar(0, totalSize)
    prog.updateAmount(count * blockSize)
    percentage = int(str(prog))
    if percentage >= 100:
        percentage = -1
        for userid in playerlib.getUseridList("#all"):
            if addmap_progressbar == 1:
                usermsg.hudhint(userid, "Downloading Map: " + addmap_currentmap + " - 100%")
    addmap_dlpercent = percentage

def ProgressBarDisplay():
    if addmap_progressbar == 1:
        if not addmap_dlpercent == -1:
            for userid in playerlib.getUseridList("#all"):
                usermsg.hudhint(userid, "Downloading Map: " + addmap_currentmap + " - " + str(addmap_dlpercent) + "%")
    gamethread.delayedname(0.5, "ProgressBarDisplay", ProgressBarDisplay)

# Very hacky method of retrieving download links from FPSbanana.
# If FPSbanana changes, the method will need to be updated.
class FPSbanana(threading.Thread):
    def __init__(self, mapname, add, overwrite, userid):
        self.mapname, self.add, self.overwrite, self.userid = mapname, add, overwrite, userid
        threading.Thread.__init__(self)

    def run(self):
        global addmap_currentmap
        conprint(self.userid, "[AddMap] Checking FPSbanana for %s!" % self.mapname)
        self.id = self.getID()
        if self.id:
            url = self.getDownloads()
            if url:
                addmap_currentmap = ""
                AddMap(self.mapname, self.add, self.overwrite, url).start()

    def getID(self):
        global addmap_currentmap
        try:
            if es.getgame() in gameSupport:
                searchurl = "http://www.fpsbanana.com/maps/search?s%5Bmaps.name%5D=" + self.mapname + "&s%5Bmaps.tags%5D=&s%5Bmaptypes.catid%5D=" + str(gameSupport[es.getgame()]) + "&s%5Busers.name%5D=&s%5Bmaps.author%5D=&s%5Bfiles.size%5D=0&s%5Bmaps.rating%5D=0&s%5Bmaps.players%5D=&s%5Bmaps.id%5D=&stype=all"
                conprint(self.userid, "[AddMap] Retrieving FPSbanana search results...")
                search = urllib.urlopen(searchurl).read()
                id = None
                for line in search.split("\n"):
                    if "<b>" + self.mapname + "</b>" in line:
                        id = line.split("http://www.fpsbanana.com/maps/")[2].split('"')[0]
                        break
                if id:
                    conprint(self.userid, "[AddMap] %s was found on FPSbanana!" % self.mapname)
                else:
                    addmap_currentmap = ""
                    conprint(self.userid, "[AddMap] %s was not found on FPSbanana!" % self.mapname)
                return id
            else:
                conprint(self.userid, "[AddMap] %s is unsupported!" % es.getgame())
        except:
            addmap_currentmap = ""
            conprint(self.userid, "[AddMap] Couldn't check FPSbanana for %s!" % self.mapname)

    def getDownloads(self):
        global addmap_currentmap
        try:
            downloadurl = "http://www.fpsbanana.com/maps/download/" + self.id
            conprint(self.userid, "[AddMap] Retrieving download page...")
            download = urllib.urlopen(downloadurl).read()
            url = None
            for line in download.split("\n"):
                if "<strong>DOWNLOAD</strong>" in line:
                    checkurl = line.split('<a style="margin:0px 50px 0px 50px" class="green" href="')[1].split('"><strong>DOWNLOAD</strong>')[0]
                    if "&ext=" in checkurl:
                        ext = checkurl.split("&ext=")[1]
                        if ext in addmap_allowedexts:
                            if self.checkURL(checkurl):
                                url = checkurl
                                break
            if url:
                conprint(self.userid, "[AddMap] Found a download link for %s!" % self.mapname)
            else:
                addmap_currentmap = ""
                conprint(self.userid, "[AddMap] Couldn't find a download link for %s!" % self.mapname)
            return url
        except:
            addmap_currentmap = ""
            conprint(self.userid, "[AddMap] Couldn't check FPSbanana for %s!" % self.mapname)

    def checkURL(self, url):
        try:
            urllib.urlopen(url).readline()
        except:
            return False
        return True

class AddMap(threading.Thread):
    def __init__(self, map, add, overwrite, url = None, userid = None):
        self.map, self.add, self.overwrite, self.url, self.userid = map, add, overwrite, url, userid
        threading.Thread.__init__(self)

    def run(self):
        global addmap_currentmap
        try:
            if addmap_currentmap == "":
                addmap_currentmap = self.map
                if not self.getMapExists() or int(self.overwrite) == 1:
                    if self.url:
                        mapurl = self.url
                    else:
                        mapurl = self.findMap()
                    if mapurl:
                        self.downloadMap(mapurl)
                    else:
                        conprint(self.userid, "[AddMap] %s is not in the maplist!" % self.map)
                        if addmap_fpsbanana == 1:
                            FPSbanana(self.map, self.add, self.overwrite, self.userid).start()
                        else:
                            addmap_currentmap = ""
                else:
                    addmap_currentmap = ""
                    conprint(self.userid, "[AddMap] %s already exists on server!" % self.map)
            else:
                conprint(self.userid, "[AddMap] Please wait until the current map download is completed.")
        except:
            addmap_currentmap = ""
            conprint(self.userid, "[AddMap] An unknown error occured.")

    def findMap(self):
        conprint(self.userid, "[AddMap] Creating list of available maps...")
        maps = getMaplistFromFile()
        mapurl = None
        if self.map in maps:
            if self.checkURL(maps[self.map]):
                conprint(self.userid, "[AddMap] Map located in maplist!")
                mapurl = maps[self.map]
        if not mapurl:
            maps = self.getMaplistFromUrl()
            if len(maps) > 0:
                for url in maps:
                    for checkmap in maps[url]:
                        if checkmap.split(".")[0] == self.map.split(".")[0]:
                            checkurl = "%s%s" % (url, checkmap)
                            if self.checkURL(checkurl):
                                conprint(self.userid, "[AddMap] Map located in maplist!")
                                mapurl = checkurl
                                break
        return mapurl

    def getMapExists(self):
        return os.path.exists("%s\maps\%s.bsp" % (str(es.ServerVar("eventscripts_gamedir")), self.map))

    def getMaplistFromUrl(self):
        maps = {}
        try:
            if len(addmap_urls) > 0:
                for url in addmap_urls:
                    maps[url] = []
                    html = urllib.urlopen(url).read()
                    for line in html.split("\n"):
                        if len(line.split('"')) >= 5:
                            map = line.split('"')[5]
                            if map.endswith("bsp") or map.endswith("bz2") or map.endswith("zip"):
                                maps[url].append(map)
                                self.writeMap(map.split(".")[0], "%s%s" % (url, map))
        except:
            pass
        return maps

    def writeMap(self, map, url):
        try:
            path = "%s/maps.txt" % es.getAddonPath("es_addmap")
            if os.path.exists(path):
                if not map in getMaplistFromFile():
                    maps = open(path, "a")
                    maps.write("%s,%s\n" % (map, url))
                    maps.close()
        except:
            pass

    def downloadMap(self, mapurl):
        global addmap_currentmap
        try:
            mapext = None
            if "&ext=" in mapurl:
                mapext = mapurl.split("=")
                x = len(mapext)-1
                mapext = "." + mapext[x]
            else:
                mapext = mapurl.split(".")
                if len(mapext) > 0:
                    x = len(mapext)-1
                    mapext = mapext[x]
            if mapext.replace(".", "", 1) in addmap_allowedexts:
                filename = "%s%s.%s" % (addmap_downloadpath, self.map, mapext.replace(".", "", 1))
                conprint(self.userid, "[AddMap] Downloading %s..." % self.map)
                addmap_currentmap = self.map
                gamethread.delayedname(addmap_timeout, "DLTimeout", DLTimeout)
                urllib.urlretrieve(mapurl, filename, reporthook=MapReportHook)
                gamethread.cancelDelayed("DLTimeout")
                addmap_currentmap = ""
                conprint(self.userid, "[AddMap] %s was downloaded successfully!" % self.map)
                if addmap_fastdownload == 1:
                    if filename.endswith(".zip"):
                        filename = self.ZIP_Decompress(filename)
                        filename = self.BZ2_Compress(filename)
                    if filename.endswith(".rar"):
                        filename = self.RAR_Decompress(filename)
                        filename = self.BZ2_Compress(filename)
                    if filename.endswith(".bsp"):
                        filename = self.BZ2_Compress(filename)
                    if filename.endswith(".bz2"):
                        c = self.FTPUpload(filename)
                        if c:
                            if not os.path.exists(filename.replace(".bz2", "", 1)):
                                bspfilename = self.BZ2_Decompress(filename)
                                MoveFile(bspfilename)
                            else:
                                MoveFile(filename.replace(".bz2", "", 1))
                            MoveFile(filename)
                            conprint(self.userid, "[AddMap] %s has been added to the server and is ready to be run!" % self.map)
                            addToMapLists(self.map)
                    else:
                        conprint(self.userid, "[AddMap] An error occured whilst preparing %s for fastdownload!" % self.map)
                else:
                    if filename.endswith(".zip"):
                        filename = self.ZIP_Decompress(filename)
                    if filename.endswith(".rar"):
                        filename = self.RAR_Decompress(filename)
                    if filename.endswith(".bz2"):
                        filename = self.BZ2_Decompress(filename)
                    MoveFile(filename)
                    conprint(self.userid, "[AddMap] %s has been added to the server and is ready to be run!" % self.map)
                    addToMapLists(self.map)
            else:
                addmap_currentmap = ""
                conprint(self.userid, "[AddMap] File extension unrecognised: %s. Download aborted." % mapext.replace(".", "", 1))
        except Exception, e:
            addmap_currentmap = ""
            gamethread.cancelDelayed("DLTimeout")
            conprint(self.userid, e)

    def checkURL(self, url):
        try:
            urllib.urlopen(url).readline()
        except:
            return False
        return True

    def BZ2_Compress(self, bz2file):
        conprint(self.userid, "[AddMap] Compressing BSP file...")
        output = bz2file + ".bz2"
        if os.path.exists(bz2file):
            normfile = open(bz2file, "rb").read()
            file = bz2.BZ2File(output, "w")
            file.write(normfile)
            file.close()
            return output
        return None

    def BZ2_Decompress(self, normfile):
        conprint(self.userid, "[AddMap] Decompressing BZ2 file...")
        output = normfile.replace(".bz2", "")
        if os.path.exists(normfile):
            bz2file = bz2.BZ2File(normfile, "r").read()
            file = open(output, "wb")
            file.write(bz2file)
            file.close()
            return output
        return None

    def ZIP_Decompress(self, normfile):
        conprint(self.userid, "[AddMap] Decompressing ZIP file...")
        if os.path.exists(normfile):
            zfobj = zipfile.ZipFile(normfile)
            for name in zfobj.namelist():
                fname = name.split("/")
                if len(fname) > 0:
                    x = len(fname)-1
                    fname = fname[x]
                else:
                    fname = name
                if name.endswith(".bsp"):
                    outfile = open(addmap_downloadpath + fname, "wb")
                    outfile.write(zfobj.read(name))
                    outfile.close()
                    return addmap_downloadpath + fname
        return None

    def RAR_Decompress(self, rarfile):
        conprint(self.userid, "[AddMap] Decompressing RAR file...")
        if os.path.exists(rarfile):
            for file in os.listdir("%s/temp/rar/" % es.getAddonPath("es_addmap")):
                try: os.remove("%s/temp/rar/%s" % (es.getAddonPath("es_addmap"), file))
                except: pass
            os.system('\"\"%s\" e \"%s\" \"%s/temp/rar/\"' % (addmap_rarcmd, rarfile, es.getAddonPath("es_addmap")))
            path = None
            for file in os.listdir("%s/temp/rar/" % es.getAddonPath("es_addmap")):
                if file.endswith(".bsp"):
                    path = "%s/temp/rar/%s" % (es.getAddonPath("es_addmap"), file)
            return path
        return None

    def FTPUpload(self, filename):
        try:
            conprint(self.userid, "[AddMap] Opening connection to FTP...")
            ftp = ftplib.FTP()
            conprint(self.userid, "[AddMap] Connecting to %s:%s..." % (addmap_ftphost, str(addmap_ftpport)))
            ftp.connect(addmap_ftphost, addmap_ftpport)
            try:
                conprint(self.userid, "[AddMap] Logging in as %s..." % addmap_ftplogin)
                ftp.login(addmap_ftplogin, addmap_ftppassword)
                ftp.cwd(addmap_ftpmappath)
                name = os.path.split(filename)[1]
                if not name in ftp.nlst() or addmap_ftpoverwrite == 1:
                    f = open(filename, "rb")
                    conprint(self.userid, "[AddMap] Uploading %s to FTP..." % self.map)
                    ftp.storbinary("STOR %s" % name, f)
                    conprint(self.userid, "[AddMap] %s was uploaded to the FTP successfully!" % self.map)
                    f.close()
                else:
                    conprint(self.userid, "[AddMap] %s already exists on the server!")
                ftp.quit()
                return True
            except:
                conprint(self.userid, "[AddMap] An unknown error occurred during FTP transfer.")
                return False
        except:
            conprint(self.userid, "[AddMap] Could not connect to %s:%s!" % (addmap_ftphost, str(addmap_ftpport)))
            return False

def MoveFile(ffrom):
    try:
        fto = ffrom.split("/")
        x = len(fto)-1
        fto = addmap_installpath + fto[x]
        if os.path.exists(fto):
            os.remove(fto)
        os.rename(ffrom, fto)
    except:
        pass

def getMaplistFromFile():
    maplist = {}
    try:
        path = "%s/maps.txt" % es.getAddonPath("es_addmap")
        if os.path.exists(path):
            maps = open(path, "r").read()
            for map in maps.split("\n"):
                if not map.strip() == "" and not map.startswith("//"):
                    map = map.split(",")
                    maplist[map[0]] = map[1]
        return maplist
    except:
        return maplist

def addToMapLists(newmap):
    maplistpath = es.ServerVar("eventscripts_gamedir") + "/maplist.txt"
    maplist = open(maplistpath, "r").read()
    stop = 0
    for map in maplist.split("\n"):
        if map.strip() == newmap:
            stop = 1
            break
    if stop == 0:
        maplist = open(maplistpath, "a")
        mapcycle = open(es.ServerVar("eventscripts_gamedir") + "/mapcycle.txt", "a")
        if os.path.exists(es.ServerVar("eventscripts_gamedir") + "/cfg/mani_admin_plugin/votemaplist.txt"):
            votemaplist = open(es.ServerVar("eventscripts_gamedir") + "/cfg/mani_admin_plugin/votemaplist.txt", "a")
        else:
            votemaplist = None
        maplist.write("\n%s" % newmap)
        mapcycle.write("\n%s" % newmap)
        if votemaplist:
            votemaplist.write("\n%s" % newmap)
        maplist.close()
        mapcycle.close()
        if votemaplist:
            votemaplist.close()

def player_say(event_var):
    if event_var["text"].lower() == "!maps":
        createMapList(event_var["userid"])

def createMapList(userid):
    if es.getplayersteamid(userid) in addmap_admins:
        maps = getMaplistFromFile()
        p_maps = popuplib.easymenu("maps", "_popup_choice", downloadPopupMap)
        p_maps.settitle("-AddMap-\nAvailable Maps")
        for map in maps:
            if not os.path.exists(addmap_installpath + map + ".bsp"):
                if len(addmap_prefix) == None or map.split("_")[0] in addmap_prefix:
                    p_maps.addoption("%s,%s" % (map, maps[map]), map)
        p_maps.send(userid)
    else:
        conprint(userid, "[AddMap] You are not authorised to run this command.")

def downloadPopupMap(userid, choice, popup):
    AddMap(choice.split(",")[0], int(addmap_addtomaplist), 0, choice.split(",")[1], userid).start()

def DLTimeout():
    conprint(None, "[AddMap] Download timed out.")
    gamethread.delayed(0.2, es.reload, "es_addmap")

def AddMap_Cancel():
    es.reload("es_addmap")

def conprint(userid, text):
    if userid:
        usermsg.echo(str(userid), text)
    else:
        es.dbgmsg(0, text)